#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum TimeUnit {
    #[serde(rename = "DAYS")]
    Days,
    #[serde(rename = "HOURS")]
    Hours,
    #[serde(rename = "MINUTES")]
    Minutes,
    #[serde(rename = "SECONDS")]
    Seconds,
    #[serde(rename = "MILLISECONDS")]
    Milliseconds,
    #[serde(rename = "MICROSECONDS")]
    Microseconds,
    #[serde(rename = "NANOSECONDS")]
    Nanoseconds,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl TimeUnit {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            TimeUnit::Days => "DAYS",
            TimeUnit::Hours => "HOURS",
            TimeUnit::Minutes => "MINUTES",
            TimeUnit::Seconds => "SECONDS",
            TimeUnit::Milliseconds => "MILLISECONDS",
            TimeUnit::Microseconds => "MICROSECONDS",
            TimeUnit::Nanoseconds => "NANOSECONDS",
            TimeUnit::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for TimeUnit {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for TimeUnit {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for TimeUnit {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<TimeUnit, conjure_object::plain::ParseEnumError> {
        match v {
            "DAYS" => Ok(TimeUnit::Days),
            "HOURS" => Ok(TimeUnit::Hours),
            "MINUTES" => Ok(TimeUnit::Minutes),
            "SECONDS" => Ok(TimeUnit::Seconds),
            "MILLISECONDS" => Ok(TimeUnit::Milliseconds),
            "MICROSECONDS" => Ok(TimeUnit::Microseconds),
            "NANOSECONDS" => Ok(TimeUnit::Nanoseconds),
            v => v.parse().map(|v| TimeUnit::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for TimeUnit {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<TimeUnit, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the TimeUnit enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
